# Security Policy

## Reporting a Vulnerability

We take security issues in our project seriously. If you discover any vulnerabilities or security concerns,
please report them to us immediately. We appreciate your help in making our project secure.

To report a vulnerability, please follow these steps:

1. **Privately** share the details of the vulnerability with us by sending an email to
    ```
    security@openitcockpit.io
    ```
   Please avoid disclosing the details publicly until we have had a chance to address the issue.

2. Provide us with a clear description of the vulnerability, including the steps to reproduce it.
   If possible, please include any relevant logs, screenshots, or code snippets that can help us understand and reproduce the issue.

3. Once the vulnerability has been resolved, we will publicly acknowledge your contribution, unless you prefer to remain anonymous.

## Responsible Disclosure

We kindly request that you follow responsible disclosure principles by not disclosing any vulnerabilities publicly
until we have had a reasonable amount of time to address them. We commit to providing timely updates on the progress
of fixing the reported vulnerability and to crediting you for your contribution.

## Disclosed Vulnerabilities

All reported security vulnerabilities are publicly listed at:
https://openitcockpit.io/security/

## Contact

If you have any questions or need further assistance regarding security-related matters, please
contact us at `security@openitcockpit.io`.

We appreciate your efforts to improve the security of our project!
